#!/bin/bash

minutes=$1
mode="$2"   # can be local or remote  ..if local, don't use ether filter

if [ ! -e /tmp/logs ] ; then mkdir /tmp/logs/ ;fi

pidfile=/var/run/startcapture.pid
mymacaddr=$(LC_ALL=C ifconfig eth0 | head -1 | sed -e 's/^.*HWaddr *\([a-f0-9:]*\).*$/\1/')

SNAPLEN="-s 0"


if [ -e "$pidfile" ];then 				#if there is a pidfile check its content
	oldpid=$(cat $pidfile)
	if [ "$(grep -q tcpdump /proc/${oldpid}/cmdline 2>&1 >/dev/null; echo $?)" == 0 ]; then 			#if the pid found in pidfile exists in proc and contains tcpdump, exit 1
		echo "retval: 1"
		exit 1
	else	
		#echo "found dead pidfile, removing";
		rm $pidfile
	fi
fi


if [ "$mode" == "local" ];then
	DEVICE="lo"
	FILTER=" ((portrange 3215-3229 or portrange 5060-5069) and (udp or tcp) and not port 514)"
fi
if [ "$mode" == "remote" ];then 
	FILTER=" ether host $mymacaddr and ((portrange 3215-3229 or portrange 5060-5069) and (udp or tcp) and not port 514)"
	DEVICE="eth0"
fi



nohup tcpdump -a -U -i $DEVICE -w /tmp/logs/capture.cap -p -n  ${SNAPLEN} "${FILTER}" < /dev/null >/dev/null 2>/dev/null &
pid=$!
echo "${pid}" > $pidfile



echo "retval: $?"
at now + ${minutes} minutes <<<"logger 'stopping tcpdump capture';  /usr/bin/sudo kill $pid; rm /var/run/startcapture.pid" 2>&1 >/dev/null
# < /dev/null >/dev/null 2>/dev/null &
